#include "inttree.h"

void inorder(inttree *p, void (*op)(inttree *))
{
	if(p) {
        	inorder(p->left,op);
		(*op)(p);
        	inorder(p->right,op);
	}
}

void preorder(inttree *p, void (*op)(inttree *))
{
	if(p) {
		(*op)(p);
		preorder(p->left,op);
		preorder(p->right,op);
	}
}

void postorder(inttree *p, void (*op)(inttree *))
{
	if(p) {
		postorder(p->left,op);
		postorder(p->right,op);
		(*op)(p);
	}
}

int countnodes(inttree *p)
{
	return p ? countnodes(p->left) + countnodes(p->right) + 1 : 0;
}

#define max(a,b)	((a) > (b) ? (a) : (b))

int countlevels(inttree *p)
{
	return p ? max(countlevels(p->left),countlevels(p->right)) + 1 : 0;
}

inttree *buildtree(int *array, int i, int size)
{
	inttree *p;

	if(i >= size)
		return NULL;
	else {
		if(!(p = malloc(sizeof(inttree)))) {
			fprintf(stderr,"Errore di allocazione\n");
        		exit(-1);
		}
		p->left = buildtree(array, 2 * i + 1, size);
		p->right = buildtree(array, 2 * i + 2, size);
		p->dato = array[i];
		return p; 
	}
}


